package com.sumsg.getsettings;

import android.content.ContentResolver;
import android.database.ContentObserver;
import android.os.Handler;
import android.os.Looper;
import android.os.UserHandle;
import android.provider.Settings;
import android.content.Context;
import android.util.Log;

import java.util.HashMap;
import java.util.Map;

import io.flutter.plugin.common.EventChannel;

public class SettingsValueChangeContentObserver extends ContentObserver {
    public Context mContext;
    public EventChannel.EventSink eventStateSink;

    public SettingsValueChangeContentObserver(Handler handler) {
        super(handler);
    }

    public SettingsValueChangeContentObserver() {
        super(new Handler(Looper.getMainLooper()));
    }

    public void register(Context applicationContext) {
        mContext = applicationContext;
        ContentResolver resolver = mContext.getContentResolver();
        resolver.registerContentObserver(Settings.System.getUriFor(
                Settings.System.ACCELEROMETER_ROTATION), false, this);
        // resolver.registerContentObserver(Settings.System.getUriFor(
        // Settings.System.BLUETOOTH_ON), false, this);

        updateSettings();
    }

    public void registerEvent(EventChannel.EventSink event) {
        eventStateSink = event;
    }

    void updateSettings() {
        Map<String, Object> map = new HashMap<>();
        map.put("isRotationOn", isRotationOn());
        // map.put("isBluetoothOn", isBluetoothOn());
        if (eventStateSink != null) {
            eventStateSink.success(map);
        }
    }

    ///
    public boolean isRotationOn() {
        return (android.provider.Settings.System.getInt(mContext.getContentResolver(),
                Settings.System.ACCELEROMETER_ROTATION, 0) == 1);
    }

    // public boolean isBluetoothOn() {
    // return
    // (android.provider.Settings.System.getInt(mContext.getContentResolver(),
    // Settings.System.BLUETOOTH_ON, 0) == 1);
    // }
    @Override
    public void onChange(boolean selfChange) {
        super.onChange(selfChange);
        updateSettings();
    }

    public void stop() {
        mContext.getContentResolver().unregisterContentObserver(this);
    }
}
